Traffic Light Simulation by Will Saada, Maxine Xin, Jojo Zhou

How to run:
In order to run the program the user first must call the makefile which can be dome by simply calling the make command.  Next the program will be run by the following ./testAnimator [name of input file].  When the program begins you will see an outline of the roads and its initial state.  Press enter to move the clock by one and watch the cars move.  The program requires no lower than 6 seconds for the yellow light in order to process left turns with trucks.

How it works:
The object oriented design in our code is built around the Traffic Simulation class which puts everything together to make this run.  The vehicle base class stores a cars attributes such as the type or car, car size and the turn of the given car.  The lane class stores a vector of vehiclebase pointers.  This way a car is stored where its located in the lane.  A car of size two will have two side by side pointers when it is in the vector.  The lane class also contains methods to store attributes of the lane.  For example, isCarEntering() will check to make sure that the entire car enters the lane before a new car can be generated.  4 lane objects are built to represent each road.  These objects are stored and manipulated in the Traffic Simulation class.  Additonally, the Traffic Simulation will have a CarGenerator object, and a Light Object.  The CarGenerator is created by including the probabilities of whether or not a car will enter an intersection and the probability of vehicle type and of turn type.  The probabilities and a random generator are stored in this object which has two methods.  One returns a boolean based on if a car is coming or not and the other returns a VehicleBase object.  The light class is simple,  the object is created by inputing the time at green and yellow.  And a boolean which determines if it begins at red or green.  The light is incremented by one tick every cycle.  The traffic simulation class puts all of this together and calls upon Professor Lawson's animator class to print the contents of each lane.  The file is read and most of the objects are created and called upon in the testAnimator Class.
